// Code generated by cdpgen. DO NOT EDIT.

package css

import (
	"github.com/mafredri/cdp/rpcc"
)

// FontsUpdatedClient is a client for FontsUpdated events. Fires whenever a
// web font is updated. A non-empty font parameter indicates a successfully
// loaded web font
type FontsUpdatedClient interface {
	// Recv calls RecvMsg on rpcc.Stream, blocks until the event is
	// triggered, context canceled or connection closed.
	Recv() (*FontsUpdatedReply, error)
	rpcc.Stream
}

// FontsUpdatedReply is the reply for FontsUpdated events.
type FontsUpdatedReply struct {
	Font *FontFace `json:"font,omitempty"` // The web font that has loaded.
}

// MediaQueryResultChangedClient is a client for MediaQueryResultChanged events.
// Fires whenever a MediaQuery result changes (for example, after a browser
// window has been resized.) The current implementation considers only
// viewport-dependent media features.
type MediaQueryResultChangedClient interface {
	// Recv calls RecvMsg on rpcc.Stream, blocks until the event is
	// triggered, context canceled or connection closed.
	Recv() (*MediaQueryResultChangedReply, error)
	rpcc.Stream
}

// MediaQueryResultChangedReply is the reply for MediaQueryResultChanged events.
type MediaQueryResultChangedReply struct {
}

// StyleSheetAddedClient is a client for StyleSheetAdded events. Fired
// whenever an active document stylesheet is added.
type StyleSheetAddedClient interface {
	// Recv calls RecvMsg on rpcc.Stream, blocks until the event is
	// triggered, context canceled or connection closed.
	Recv() (*StyleSheetAddedReply, error)
	rpcc.Stream
}

// StyleSheetAddedReply is the reply for StyleSheetAdded events.
type StyleSheetAddedReply struct {
	Header StyleSheetHeader `json:"header"` // Added stylesheet metainfo.
}

// StyleSheetChangedClient is a client for StyleSheetChanged events. Fired
// whenever a stylesheet is changed as a result of the client operation.
type StyleSheetChangedClient interface {
	// Recv calls RecvMsg on rpcc.Stream, blocks until the event is
	// triggered, context canceled or connection closed.
	Recv() (*StyleSheetChangedReply, error)
	rpcc.Stream
}

// StyleSheetChangedReply is the reply for StyleSheetChanged events.
type StyleSheetChangedReply struct {
	StyleSheetID StyleSheetID `json:"styleSheetId"` // No description.
}

// StyleSheetRemovedClient is a client for StyleSheetRemoved events. Fired
// whenever an active document stylesheet is removed.
type StyleSheetRemovedClient interface {
	// Recv calls RecvMsg on rpcc.Stream, blocks until the event is
	// triggered, context canceled or connection closed.
	Recv() (*StyleSheetRemovedReply, error)
	rpcc.Stream
}

// StyleSheetRemovedReply is the reply for StyleSheetRemoved events.
type StyleSheetRemovedReply struct {
	StyleSheetID StyleSheetID `json:"styleSheetId"` // Identifier of the removed stylesheet.
}
